from pathlib import Path

from setuptools import find_packages, setup

# Read the contents of README file
source_root = Path(".")
with (source_root / "README.md").open(encoding="utf-8") as f:
    long_description = f.read()

# Read the requirements
# with (source_root / "requirements.txt").open(encoding="utf8") as f:
#     requirements = f.readlines()

version = "0.0.10"

# with (source_root / "src" / "simple_report" / "version.py").open(
#     "w", encoding="utf-8"
# ) as f:
#     f.writelines(
#         [
#             '"""This file is auto-generated by setup.py, please do not alter."""\n',
#             f'__version__ = "{version}"\n',
#             "",
#         ]
#     )

setup(
    name="simple-report",
    version=version,
    author="Douglas Sgrott",
    author_email="doug.sgrott@gmail.com",
    packages=find_packages(),
    # package_dir={"": "simple_report"},
    url="https://github.com/dougsgrott/simple-report",
    license="MIT",
    description="Simple HTML report generation using Python",
    python_requires=">=3.6",
    # install_requires=requirements,
    extras_require={
        "notebook": [
            "jupyter-client>=5.3.4",
            "jupyter-core>=4.6.3",
            "ipywidgets>=7.5.1",
        ],
    },
    package_data={
        "simple_report": ["py.typed"],
    },
    include_package_data=True,
    # classifiers=[
    #     "Development Status :: 5 - Production/Stable",
    #     "Topic :: Software Development :: Build Tools",
    #     "License :: OSI Approved :: MIT License",
    #     "Environment :: Console",
    #     "Operating System :: OS Independent",
    #     "Intended Audience :: Science/Research",
    #     "Intended Audience :: Developers",
    #     "Intended Audience :: Financial and Insurance Industry",
    #     "Intended Audience :: Healthcare Industry",
    #     "Topic :: Scientific/Engineering",
    #     "Framework :: IPython",
    #     "Programming Language :: Python :: 3",
    #     "Programming Language :: Python :: 3.6",
    #     "Programming Language :: Python :: 3.7",
    #     "Programming Language :: Python :: 3.8",
    #     "Programming Language :: Python :: 3.9",
    #     "Programming Language :: Python :: 3.10",
    # ],
    # keywords="html data-science data-analysis python jupyter ipython",
    # long_description=long_description,
    # long_description_content_type="text/markdown",
    # entry_points={
    #     "console_scripts": [
    #         "simple_report = simple_report.controller.console:main"
    #     ]
    # },
    # options={"bdist_wheel": {"universal": True}},
)
